﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Dynamic;

namespace ConsoleApplication3
{
    public class DynamicAnimal : DynamicObject
    {
        public override bool TryInvokeMember(InvokeMemberBinder binder, object[] args, out object result)
        {
            bool success = base.TryInvokeMember(binder, args, out result);
            //如果方法不存在，请将result 这个out参数赋值为null            
            if (!success)
            {
                result = null;
            }
            //如果这个地方返回false 将会引发异常            
            return true;
        }
    }

    public class Duck : DynamicAnimal
    {
        public string Quack()
        {
            return "鸭子嘛，就是Quack吧。";
        }
    }

    public class Human : DynamicAnimal
    {
        public string Talk()
        {
            return "人类是用Talk,而不是Quack";
        }
    }
}
